package com.vp.plugin.sample.modelviewchecker;

import java.util.*;

import com.vp.plugin.*;
import com.vp.plugin.diagram.*;
import com.vp.plugin.model.*;
import com.vp.plugin.sample.modelviewchecker.ui.*;

public class ModelViewChecker {
	
	public static void check() {
		IProject project = ApplicationManager.instance().getProjectManager().getProject();
		
		{
			// load all diagram elements, for avoid lazy problem
			IDiagramUIModel[] diagrams = project.toDiagramArray();
			int count = diagrams == null ? 0 : diagrams.length;
			for (int i = 0; i < count; i++) {
				diagrams[i].toShapeUIModelArray();
				diagrams[i].toConnectorUIModelArray();
			}
		}
		
		Collection collection = new ArrayList(); // <IModelElement>
		check(project.toModelElementArray(), collection);
		
		IModelElement[] models = new IModelElement[collection.size()];
		collection.toArray(models);
		
		ApplicationManager.instance().getViewManager().showDialog(new ModelViewDialog(models));
	}
	
	private static void check(IModelElement[] models, Collection collection) {
		int count = models == null ? 0 : models.length;
		for (int i = 0; i < count; i++) {
			IModelElement model = models[i];
			if (! isIgnore(model)) {
				IDiagramElement[] views = model.getDiagramElements();
				if (views == null || views.length == 0) {
					collection.add(model);
				}
			}
			check(model.toChildArray(), collection);
		}
	}
	private static boolean isIgnore(IModelElement model) {
		// they should must no views
		return 
			model instanceof IDataType || 
			model instanceof IAttribute || 
			model instanceof IOperation || 
			model instanceof IParameter || 
			model instanceof IDBColumn || 
			model instanceof IStereotype || 
			model instanceof ITaggedValue || 
			model instanceof ITaggedValueContainer;
	}
}